#pragma once

// C++ system level
#include <string>
#include <functional>

// ESP32 specific
#include "freertos/FreeRTOS.h"
#include "freertos/queue.h"

// project specific
#include <SpiderLib.hpp>
// #include <LambdaTask.hpp>
#include "SiliconTorch/Service/ServiceManager.hpp"

// qthing stuff
// #include ""

// misc
#include <nlohmann/json.hpp>



namespace SiliconTorch {



  class SiliconTorch : public SpiderLib::HasMQTT {

    public:

      SiliconTorch();

      void start();

      nlohmann::json getDeviceJSON() const;
      void publishDeviceJSON(bool pretty = false) const;

    private:

      //SiliconTorch::ServiceManager::ServiceManager* serviceManager = NULL;

  };
}
