#pragma once

#include <qthing.h>

#include "driver/ledc.h"


ledc_channel_t getNextLEDChannel();


class FastDimmer {
  public:
    FastDimmer(uint8_t gpio);
    void setBrightness(float b);
  
  private:
    ledc_channel_t channel = getNextLEDChannel();
};
